

#ifndef	__VJEFFECT_H
#define	__VJEFFECT_H


#define	VJ_WIDTHLIMIT	(800)		//蓾őʉTCY
#define	VJ_HEIGHTLIMIT	(600)		//蓾őʏcTCY



class CVJEffecter;

#define	VJPARAMINFO_POSX	1
#define	VJPARAMINFO_POSY	2

typedef struct
{
	int type;
	int reserved[3];
} VJPARAMINFO;



typedef CVJEffecter* _GETVJEFFECTER();

#define	VJ_EFFECT_COPY			0x00001001
#define	VJ_EFFECT_MIX			0x00001002
#define	VJ_EFFECT_MODIFY		0x00001003
#define	VJ_EFFECT_GENERATE		0x00001004
//#define	VJ_EFFECT_SYSTEM		0x00001010

#define	VJ_EFFECT_DIRECTDRAW4	0x00010000
#define	VJ_EFFECT_DIRECT3D		0x00100000		// pOutChannel[0]=out surface [2]=D3DDevice


typedef struct
{
	int cbSize;
	int type;
	char *cmdName;
	int nOutChannel;
	int nInChannel;
	int nParam;
	VJPARAMINFO *pParam;
	_GETVJEFFECTER *GetObj;

} VJOBJINFO;


class CVJEffecter
{
public:
	virtual void Release()=NULL;
	virtual int MessageProc(int msg,DWORD wParam,DWORD lParam)=NULL;
	virtual VJOBJINFO* GetInfo()=NULL;
};



typedef struct
{
	enum TYPE{DISABLE=0,CONSTANT=1,VARIABLE=2} type;
	int data;
} VJPARAMDATA;

#define	VJM_INIT				0x00000010
#define	VJM_EFFECT				0x00001000

typedef struct
{
	int cbSize;
	int effectType;
	int nInChannel;
	void **pInChannel;
	int nOutChannel;
	void **pOutChannel;
	int nParam;
	//int *pParam;
	VJPARAMDATA *pParam;
} VJEFFECTINFO;






#endif //__VJEFFECT_H
